Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Main_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$pad=new Tonyu.classes.kernel.Pad({buttonCnt: 0,alpha: 255,active: false});
        Tonyu.globals.$pad.alpha=0;
        new Tonyu.classes.user.NetMng;
        new Tonyu.classes.user.MyChar;
      },
      fiber$main :function _trc_Main_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$pad=new Tonyu.classes.kernel.Pad({buttonCnt: 0,alpha: 255,active: false});
        Tonyu.globals.$pad.alpha=0;
        new Tonyu.classes.user.NetMng;
        new Tonyu.classes.user.MyChar;
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Mirror',
  shortName: 'Mirror',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Mirror_main() {
        "use strict";
        var _this=this;
        
        
        while (true) {
          _this.alpha=_this.playerNo==Tonyu.globals.$myNo?64:255;
          if (_this.otime>=60*20) {
            _this.alpha*=(60*30-_this.otime)/(60*10);
          }
          if (_this.otime>=60*30) {
            _this.alpha=0;
            
          } else {
            _this.drawText(_this.x-12,_this.y+24,(_this.playerNo+1)+"P","rgb(255,255,255)",16);
            _this.drawText(_this.x-12,_this.y+24+15,_this.latency+"ms","rgb(255,255,255)",12);
            
          }
          _this.otime++;
          _this.update();
          
        }
      },
      fiber$main :function _trc_Mirror_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        
        _thread.enter(function _trc_Mirror_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              _this.alpha=_this.playerNo==Tonyu.globals.$myNo?64:255;
              if (_this.otime>=60*20) {
                _this.alpha*=(60*30-_this.otime)/(60*10);
              }
              if (_this.otime>=60*30) {
                _this.alpha=0;
                
              } else {
                _this.drawText(_this.x-12,_this.y+24,(_this.playerNo+1)+"P","rgb(255,255,255)",16);
                _this.drawText(_this.x-12,_this.y+24+15,_this.latency+"ms","rgb(255,255,255)",12);
                
              }
              _this.otime++;
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"playerNo":{},"otime":{},"latency":{}}}
});
Tonyu.klass.define({
  fullName: 'user.MyChar',
  shortName: 'MyChar',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_MyChar_main() {
        "use strict";
        var _this=this;
        
        _this.otime = Tonyu.globals.$frameCount-60*5+30;
        
        _this.x=_this.rnd(Tonyu.globals.$screenWidth);
        _this.y=_this.rnd(Tonyu.globals.$screenHeight);
        _this.ox = _this.x;
        
        _this.oy = _this.y;
        
        _this.alpha=255;
        while (true) {
          if (Tonyu.globals.$myNo!=null) {
            _this.p=Tonyu.globals.$myNo;
          } else {
            _this.p=Tonyu.globals.$pat_base+11;
          }
          if (_this.getkey(37)||Tonyu.globals.$pad.getLeft()) {
            _this.x-=3;
          }
          if (_this.getkey(38)||Tonyu.globals.$pad.getUp()) {
            _this.y-=3;
          }
          if (_this.getkey(39)||Tonyu.globals.$pad.getRight()) {
            _this.x+=3;
          }
          if (_this.getkey(40)||Tonyu.globals.$pad.getDown()) {
            _this.y+=3;
          }
          _this.x=_this.clamp(16,Tonyu.globals.$screenWidth-16,_this.x);
          _this.y=_this.clamp(16,Tonyu.globals.$screenHeight-54,_this.y);
          if (Tonyu.globals.$frameCount%(1+_this.floor(Tonyu.globals.$latency/16))==0&&(_this.x!=_this.ox||_this.y!=_this.oy||Tonyu.globals.$frameCount-_this.otime>=20)) {
            _this.ox=_this.x;
            _this.oy=_this.y;
            _this.otime=Tonyu.globals.$frameCount;
            Tonyu.globals.$t2ws.send({mes: "playerXY",time: performance.now(),playerNo: Tonyu.globals.$myNo,x: _this.x,y: _this.y,latency: Tonyu.globals.$latency});
            
          }
          _this.update();
          
        }
      },
      fiber$main :function _trc_MyChar_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.otime = Tonyu.globals.$frameCount-60*5+30;
        
        _this.x=_this.rnd(Tonyu.globals.$screenWidth);
        _this.y=_this.rnd(Tonyu.globals.$screenHeight);
        _this.ox = _this.x;
        
        _this.oy = _this.y;
        
        _this.alpha=255;
        
        _thread.enter(function _trc_MyChar_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (Tonyu.globals.$myNo!=null) {
                _this.p=Tonyu.globals.$myNo;
              } else {
                _this.p=Tonyu.globals.$pat_base+11;
              }
              if (_this.getkey(37)||Tonyu.globals.$pad.getLeft()) {
                _this.x-=3;
              }
              if (_this.getkey(38)||Tonyu.globals.$pad.getUp()) {
                _this.y-=3;
              }
              if (_this.getkey(39)||Tonyu.globals.$pad.getRight()) {
                _this.x+=3;
              }
              if (_this.getkey(40)||Tonyu.globals.$pad.getDown()) {
                _this.y+=3;
              }
              _this.x=_this.clamp(16,Tonyu.globals.$screenWidth-16,_this.x);
              _this.y=_this.clamp(16,Tonyu.globals.$screenHeight-54,_this.y);
              if (Tonyu.globals.$frameCount%(1+_this.floor(Tonyu.globals.$latency/16))==0&&(_this.x!=_this.ox||_this.y!=_this.oy||Tonyu.globals.$frameCount-_this.otime>=20)) {
                _this.ox=_this.x;
                _this.oy=_this.y;
                _this.otime=Tonyu.globals.$frameCount;
                Tonyu.globals.$t2ws.send({mes: "playerXY",time: performance.now(),playerNo: Tonyu.globals.$myNo,x: _this.x,y: _this.y,latency: Tonyu.globals.$latency});
                
              }
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"otime":{},"ox":{},"oy":{}}}
});
Tonyu.klass.define({
  fullName: 'user.NetMng',
  shortName: 'NetMng',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_NetMng_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$onlineOpen=false;
        Tonyu.globals.$mirrorAry=[];
        Tonyu.globals.$latency=0;
        Tonyu.globals.$latencyMin=30000;
        Tonyu.globals.$latencyMinTime=performance.now();
        Tonyu.globals.$latencyMax=0;
        Tonyu.globals.$latencyMaxTime=performance.now();
        _this.pingFuncInterval = null;
        
        if (Tonyu.globals.$t2ws==null) {
          Tonyu.globals.$t2ws=new Tonyu.classes.user.T2WebSocket;
          
        } else {
          Tonyu.globals.$onlineOpen=true;
          
        }
        if (Tonyu.globals.$t2ws.sock==null) {
          Tonyu.globals.$t2ws.connect("testroom");
          
        }
        Tonyu.globals.$t2ws.setOnOpenListener((function anonymous_524(e) {
          
          _this.print("open");
          Tonyu.globals.$onlineOpen=true;
        }));
        Tonyu.globals.$t2ws.setOnCloseListener((function anonymous_846(e) {
          
          _this.print("close");
          Tonyu.globals.$onlineOpen=false;
        }));
        Tonyu.globals.$t2ws.setOnErrorListener((function anonymous_1102(e) {
          
          _this.print("error");
        }));
        Tonyu.globals.$t2ws.setOnMessageListener((function anonymous_1187(obj) {
          var m;
          var playerNo;
          var l;
          
          if (obj.mes=="_start") {
            Tonyu.globals.$myNo=obj.playerNo;
            _this.print("myNo:"+(Tonyu.globals.$myNo+1)+"P");
            
          } else {
            if (obj.mes=="_connection") {
              _this.print("connect:",(obj.playerNo+1)+"P");
              
            } else {
              if (obj.mes=="_close") {
                _this.print("close:",(obj.playerNo+1)+"P");
                m = Tonyu.globals.$mirrorAry[obj.playerNo];
                
                if (m) {
                  m.otime=60*25;
                  
                }
                
              } else {
                if (obj.mes=="playerXY") {
                  playerNo = obj.playerNo;
                  
                  if (playerNo==null) {
                    return _this;
                  }
                  m = Tonyu.globals.$mirrorAry[playerNo];
                  
                  if (! m) {
                    _this.print("exists:",(playerNo+1)+"P");
                    m=new Tonyu.classes.user.Mirror({playerNo: playerNo,x: - 999,y: - 999,p: playerNo,zOrder: 10,otime: 0});
                    Tonyu.globals.$mirrorAry[playerNo]=m;
                    
                  }
                  m.x=obj.x;
                  m.y=obj.y;
                  m.otime=0;
                  m.latency=obj.latency;
                  if (playerNo==Tonyu.globals.$myNo) {
                    l = _this.floor(performance.now()-obj.time);
                    
                    if (l>=0) {
                      Tonyu.globals.$latency=_this.floor(performance.now()-obj.time);
                    }
                    
                  }
                  
                }
              }
            }
          }
        }));
        while (true) {
          if (_this.getkey(1)==0&&Tonyu.globals.$touches[0].touched==1) {
            Tonyu.globals.$pad.alpha=255;
            Tonyu.globals.$pad.active=true;
            
          }
          _this.nowTime = performance.now();
          
          if (_this.nowTime-Tonyu.globals.$latencyMinTime>=10000&&Tonyu.globals.$latency>=1) {
            Tonyu.globals.$latencyMin=Tonyu.globals.$latency;
            Tonyu.globals.$latencyMinTime=_this.nowTime;
            
          }
          if (_this.nowTime-Tonyu.globals.$latencyMaxTime>=10000&&Tonyu.globals.$latency>=1) {
            Tonyu.globals.$latencyMax=Tonyu.globals.$latency;
            Tonyu.globals.$latencyMaxTime=_this.nowTime;
            
          }
          if (Tonyu.globals.$latency<Tonyu.globals.$latencyMin&&Tonyu.globals.$latency>=1) {
            Tonyu.globals.$latencyMin=Tonyu.globals.$latency;
            Tonyu.globals.$latencyMinTime=_this.nowTime;
            
          }
          if (Tonyu.globals.$latency>Tonyu.globals.$latencyMax&&Tonyu.globals.$latency>=1) {
            Tonyu.globals.$latencyMax=Tonyu.globals.$latency;
            Tonyu.globals.$latencyMaxTime=_this.nowTime;
            
          }
          _this.drawText(Tonyu.globals.$screenWidth-2-150,2,"ping:"+Tonyu.globals.$latency+"ms","rgb(255,255,255)",16);
          _this.drawText(Tonyu.globals.$screenWidth-2-150,2+20,"pingMin:"+Tonyu.globals.$latencyMin+"ms","rgb(255,255,255)",16);
          _this.drawText(Tonyu.globals.$screenWidth-2-150,2+40,"pingMax:"+Tonyu.globals.$latencyMax+"ms","rgb(255,255,255)",16);
          _this.update();
          
        }
      },
      fiber$main :function _trc_NetMng_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$onlineOpen=false;
        Tonyu.globals.$mirrorAry=[];
        Tonyu.globals.$latency=0;
        Tonyu.globals.$latencyMin=30000;
        Tonyu.globals.$latencyMinTime=performance.now();
        Tonyu.globals.$latencyMax=0;
        Tonyu.globals.$latencyMaxTime=performance.now();
        _this.pingFuncInterval = null;
        
        if (Tonyu.globals.$t2ws==null) {
          Tonyu.globals.$t2ws=new Tonyu.classes.user.T2WebSocket;
          
        } else {
          Tonyu.globals.$onlineOpen=true;
          
        }
        if (Tonyu.globals.$t2ws.sock==null) {
          Tonyu.globals.$t2ws.connect("testroom");
          
        }
        Tonyu.globals.$t2ws.setOnOpenListener((function anonymous_524(e) {
          
          _this.print("open");
          Tonyu.globals.$onlineOpen=true;
        }));
        Tonyu.globals.$t2ws.setOnCloseListener((function anonymous_846(e) {
          
          _this.print("close");
          Tonyu.globals.$onlineOpen=false;
        }));
        Tonyu.globals.$t2ws.setOnErrorListener((function anonymous_1102(e) {
          
          _this.print("error");
        }));
        Tonyu.globals.$t2ws.setOnMessageListener((function anonymous_1187(obj) {
          var m;
          var playerNo;
          var l;
          
          if (obj.mes=="_start") {
            Tonyu.globals.$myNo=obj.playerNo;
            _this.print("myNo:"+(Tonyu.globals.$myNo+1)+"P");
            
          } else {
            if (obj.mes=="_connection") {
              _this.print("connect:",(obj.playerNo+1)+"P");
              
            } else {
              if (obj.mes=="_close") {
                _this.print("close:",(obj.playerNo+1)+"P");
                m = Tonyu.globals.$mirrorAry[obj.playerNo];
                
                if (m) {
                  m.otime=60*25;
                  
                }
                
              } else {
                if (obj.mes=="playerXY") {
                  playerNo = obj.playerNo;
                  
                  if (playerNo==null) {
                    return _this;
                  }
                  m = Tonyu.globals.$mirrorAry[playerNo];
                  
                  if (! m) {
                    _this.print("exists:",(playerNo+1)+"P");
                    m=new Tonyu.classes.user.Mirror({playerNo: playerNo,x: - 999,y: - 999,p: playerNo,zOrder: 10,otime: 0});
                    Tonyu.globals.$mirrorAry[playerNo]=m;
                    
                  }
                  m.x=obj.x;
                  m.y=obj.y;
                  m.otime=0;
                  m.latency=obj.latency;
                  if (playerNo==Tonyu.globals.$myNo) {
                    l = _this.floor(performance.now()-obj.time);
                    
                    if (l>=0) {
                      Tonyu.globals.$latency=_this.floor(performance.now()-obj.time);
                    }
                    
                  }
                  
                }
              }
            }
          }
        }));
        
        _thread.enter(function _trc_NetMng_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (_this.getkey(1)==0&&Tonyu.globals.$touches[0].touched==1) {
                Tonyu.globals.$pad.alpha=255;
                Tonyu.globals.$pad.active=true;
                
              }
              _this.nowTime = performance.now();
              
              if (_this.nowTime-Tonyu.globals.$latencyMinTime>=10000&&Tonyu.globals.$latency>=1) {
                Tonyu.globals.$latencyMin=Tonyu.globals.$latency;
                Tonyu.globals.$latencyMinTime=_this.nowTime;
                
              }
              if (_this.nowTime-Tonyu.globals.$latencyMaxTime>=10000&&Tonyu.globals.$latency>=1) {
                Tonyu.globals.$latencyMax=Tonyu.globals.$latency;
                Tonyu.globals.$latencyMaxTime=_this.nowTime;
                
              }
              if (Tonyu.globals.$latency<Tonyu.globals.$latencyMin&&Tonyu.globals.$latency>=1) {
                Tonyu.globals.$latencyMin=Tonyu.globals.$latency;
                Tonyu.globals.$latencyMinTime=_this.nowTime;
                
              }
              if (Tonyu.globals.$latency>Tonyu.globals.$latencyMax&&Tonyu.globals.$latency>=1) {
                Tonyu.globals.$latencyMax=Tonyu.globals.$latency;
                Tonyu.globals.$latencyMaxTime=_this.nowTime;
                
              }
              _this.drawText(Tonyu.globals.$screenWidth-2-150,2,"ping:"+Tonyu.globals.$latency+"ms","rgb(255,255,255)",16);
              _this.drawText(Tonyu.globals.$screenWidth-2-150,2+20,"pingMin:"+Tonyu.globals.$latencyMin+"ms","rgb(255,255,255)",16);
              _this.drawText(Tonyu.globals.$screenWidth-2-150,2+40,"pingMax:"+Tonyu.globals.$latencyMax+"ms","rgb(255,255,255)",16);
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"pingFuncInterval":{},"nowTime":{}}}
});
Tonyu.klass.define({
  fullName: 'user.T2WebSocket',
  shortName: 'T2WebSocket',
  namespace: 'user',
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_T2WebSocket_main() {
        "use strict";
        var _this=this;
        
        _this.sock = null;
        
        _this.onOpen = null;
        
        _this.onClose = null;
        
        _this.onError = null;
        
        _this.onMessage = null;
        
      },
      fiber$main :function _trc_T2WebSocket_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.sock = null;
        
        _this.onOpen = null;
        
        _this.onClose = null;
        
        _this.onError = null;
        
        _this.onMessage = null;
        
        
        _thread.retVal=_this;return;
      },
      connect :function _trc_T2WebSocket_connect(roomName,url) {
        "use strict";
        var _this=this;
        var prjPath;
        var wsProtocol;
        var wsHost;
        var wsPort;
        var wsPathName;
        var url;
        var e;
        
        if (_this.sock) {
          return _this;
        }
        try {
          if (url==null) {
            prjPath = Tonyu.globals.$currentProject.getDir()._path;
            
            prjPath=prjPath?prjPath.match("/[^/]+/$"):null;
            prjPath=prjPath?prjPath[0]:"";
            wsProtocol = "wss";
            
            wsHost = "t2ws.mkbcr.net";
            
            wsPort = 443;
            
            wsPathName = location.hostname+location.pathname+prjPath;
            
            url = wsProtocol+"://"+wsHost+":"+wsPort+"/"+wsPathName;
            
            
          }
          if (roomName==null) {
            roomName="";
          }
          url=url+roomName;
          _this.sock=new WebSocket(url);
          _this.sock.addEventListener("open",(function anonymous_1261(e) {
            
            if (_this.onOpen) {
              _this.onOpen(e);
            }
          }));
          _this.sock.addEventListener("message",(function anonymous_1359(e) {
            
            _this.recv(e.data);
          }));
          _this.sock.addEventListener("close",(function anonymous_1446(e) {
            
            if (_this.onClose) {
              _this.onClose(e);
            }
            _this.sock=null;
          }));
          _this.sock.addEventListener("error",(function anonymous_1570(e) {
            
            if (_this.onError) {
              _this.onError(e);
            }
          }));
          
        } catch (e) {
          console.log("websocket connect error",e);
          
        }
      },
      fiber$connect :function _trc_T2WebSocket_f_connect(_thread,roomName,url) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var prjPath;
        var wsProtocol;
        var wsHost;
        var wsPort;
        var wsPathName;
        var url;
        var e;
        
        if (_this.sock) {
          _thread.retVal=_this;return;
          
        }
        
        _thread.enter(function _trc_T2WebSocket_ent_connect(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _thread.enterTry(1     );
              if (url==null) {
                prjPath = Tonyu.globals.$currentProject.getDir()._path;
                
                prjPath=prjPath?prjPath.match("/[^/]+/$"):null;
                prjPath=prjPath?prjPath[0]:"";
                wsProtocol = "wss";
                
                wsHost = "t2ws.mkbcr.net";
                
                wsPort = 443;
                
                wsPathName = location.hostname+location.pathname+prjPath;
                
                url = wsProtocol+"://"+wsHost+":"+wsPort+"/"+wsPathName;
                
                
              }
              if (roomName==null) {
                roomName="";
              }
              url=url+roomName;
              _this.sock=new WebSocket(url);
              _this.sock.addEventListener("open",(function anonymous_1261(e) {
                
                if (_this.onOpen) {
                  _this.onOpen(e);
                }
              }));
              _this.sock.addEventListener("message",(function anonymous_1359(e) {
                
                _this.recv(e.data);
              }));
              _this.sock.addEventListener("close",(function anonymous_1446(e) {
                
                if (_this.onClose) {
                  _this.onClose(e);
                }
                _this.sock=null;
              }));
              _this.sock.addEventListener("error",(function anonymous_1570(e) {
                
                if (_this.onError) {
                  _this.onError(e);
                }
              }));_thread.exitTry();
              __pc=2     ;break;
            case 1     :
              e=_thread.startCatch();
              {
                console.log("websocket connect error",e);
              }
            case 2     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      close :function _trc_T2WebSocket_close() {
        "use strict";
        var _this=this;
        
        if (_this.sock) {
          _this.sock.close();
          _this.sock=null;
          
        }
      },
      fiber$close :function _trc_T2WebSocket_f_close(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.sock) {
          _this.sock.close();
          _this.sock=null;
          
        }
        
        _thread.retVal=_this;return;
      },
      send :function _trc_T2WebSocket_send(d) {
        "use strict";
        var _this=this;
        
        if (_this.sock&&_this.sock.readyState==1) {
          if (Tonyu.is(d,String)||Tonyu.is(d,ArrayBuffer)||Tonyu.is(d,Blob)||_this._isTypedArray(d)) {
            _this.sock.send(d);
            
          } else {
            if (Tonyu.is(d,Object)) {
              _this.sock.send(JSON.stringify(d));
              
            } else {
              _this.sock.send(d);
              
            }
          }
          
        }
      },
      fiber$send :function _trc_T2WebSocket_f_send(_thread,d) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.sock&&_this.sock.readyState==1) {
          if (Tonyu.is(d,String)||Tonyu.is(d,ArrayBuffer)||Tonyu.is(d,Blob)||_this._isTypedArray(d)) {
            _this.sock.send(d);
            
          } else {
            if (Tonyu.is(d,Object)) {
              _this.sock.send(JSON.stringify(d));
              
            } else {
              _this.sock.send(d);
              
            }
          }
          
        }
        
        _thread.retVal=_this;return;
      },
      recv :function _trc_T2WebSocket_recv(d) {
        "use strict";
        var _this=this;
        var obj;
        var e;
        
        try {
          obj = JSON.parse(d);
          
          if (_this.onMessage) {
            _this.onMessage(obj);
            
          }
          
        } catch (e) {
          if (_this.onMessage) {
            _this.onMessage(d);
            
          }
          
        }
      },
      fiber$recv :function _trc_T2WebSocket_f_recv(_thread,d) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var obj;
        var e;
        
        try {
          obj = JSON.parse(d);
          
          if (_this.onMessage) {
            _this.onMessage(obj);
            
          }
          
        } catch (e) {
          if (_this.onMessage) {
            _this.onMessage(d);
            
          }
          
        }
        
        _thread.retVal=_this;return;
      },
      setOnOpenListener :function _trc_T2WebSocket_setOnOpenListener(l) {
        "use strict";
        var _this=this;
        
        _this.onOpen=l;
      },
      fiber$setOnOpenListener :function _trc_T2WebSocket_f_setOnOpenListener(_thread,l) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.onOpen=l;
        
        _thread.retVal=_this;return;
      },
      setOnMessageListener :function _trc_T2WebSocket_setOnMessageListener(l) {
        "use strict";
        var _this=this;
        
        _this.onMessage=l;
      },
      fiber$setOnMessageListener :function _trc_T2WebSocket_f_setOnMessageListener(_thread,l) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.onMessage=l;
        
        _thread.retVal=_this;return;
      },
      setOnCloseListener :function _trc_T2WebSocket_setOnCloseListener(l) {
        "use strict";
        var _this=this;
        
        _this.onClose=l;
      },
      fiber$setOnCloseListener :function _trc_T2WebSocket_f_setOnCloseListener(_thread,l) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.onClose=l;
        
        _thread.retVal=_this;return;
      },
      setOnErrorListener :function _trc_T2WebSocket_setOnErrorListener(l) {
        "use strict";
        var _this=this;
        
        _this.onError=l;
      },
      fiber$setOnErrorListener :function _trc_T2WebSocket_f_setOnErrorListener(_thread,l) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.onError=l;
        
        _thread.retVal=_this;return;
      },
      _isTypedArray :function _trc_T2WebSocket__isTypedArray(value) {
        "use strict";
        var _this=this;
        
        return ArrayBuffer.isView(value)&&! (value instanceof DataView);
      },
      fiber$_isTypedArray :function _trc_T2WebSocket_f__isTypedArray(_thread,value) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=ArrayBuffer.isView(value)&&! (value instanceof DataView);return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"connect":{"nowait":false},"close":{"nowait":false},"send":{"nowait":false},"recv":{"nowait":false},"setOnOpenListener":{"nowait":false},"setOnMessageListener":{"nowait":false},"setOnCloseListener":{"nowait":false},"setOnErrorListener":{"nowait":false},"_isTypedArray":{"nowait":false}},"fields":{"sock":{},"onOpen":{},"onClose":{},"onError":{},"onMessage":{}}}
});

//# sourceMappingURL=concat.js.map